<?php
namespace JHodges\PHPUnitBase;

use \PHPUnit\Framework\TestCase;

use GuzzleHttp\RequestOptions;
use GuzzleHttp\Psr7\Uri;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\UriInterface;

use Spatie\Crawler\Crawler;
use Spatie\Crawler\CrawlUrl;
use Spatie\Crawler\CrawlInternalUrls;

abstract class CrawlTest extends TestCase{

    /**
    * @return string the source domain
    **/
    abstract protected function getUrl();

    public function testCrawl(){
        $observer=new CrawlObserver();

        Crawler::create([
            RequestOptions::ALLOW_REDIRECTS => [
                'track_redirects' => true,
            ],
        ])
            ->setCrawlObserver($observer)
            ->setCrawlProfile(new CrawlInternalUrls( $this-> getUrl() ))
            //->addToCrawlQueue( CrawlUrl::create(new Uri('https://another_entry_point??')) )
            ->startCrawling( $this-> getUrl() )
        ;
        $this->assertTrue(true);
        return $observer->results;
    }

    /**
    * @depends testCrawl
    */
    public function testBrokenLinks($results){
        $errors='';
        foreach($results as $result){
            if($result['code']!=200){
                $errors.="{$result['code']} {$result['link']} (found on {$result['parent']})\n";
            }
        }
        if($errors){
            throw new \Exception("\n".$errors);
        }else{
            $this->assertTrue(true);
        }
    }
}
