<?php
namespace JHodges\PHPUnitBase;

use \PHPUnit\Framework\TestCase;

/**
* This will check (using curl) that the source
* URL redirects to the destination URL
**/

abstract class UrlRedirectTest extends TestCase{

	/**
	* Test $from redirects to $to
	* @param string $from source URL
	* @param string $to dest URL
	**/
	public function assertUrlRedirect($from,$to){
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $from);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
		$html = curl_exec($ch);
		$redirectedUrl = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL);
		curl_close($ch);
		$this->assertEquals($to,$redirectedUrl,"From: {$from}");
	}

}
